#include <lpc214x.h>
#include "sd.h"
#include "func.h"
#define SDC_CS 1<<21
#define SPI_SEL 0x00100000
#define SDC_CS_1 IOSET0|=SDC_CS;
#define SDC_CS_0 IOCLR0|=SDC_CS;
#define SDC_SECTOR_SIZE    512
#define CSD_SIZE 16	
unsigned char  msd_buffer[512];//bufor odczytu/zapisu sektora
unsigned char  csd_buffer[16];//bufor rejestru CSD
unsigned char status;
//procedury sprzetowe SPI
void init_SPI(void){
//int portConfig;
char i,temp;
	PINSEL1 = 0x000000A8; //piny portu do SSP
	SSPCR1 = 0x00; //SSP master 
	SSPCPSR=2;//preskaler SSP CLK
	SSPCR0=0x0907;//SPI1 8 bitow i ftr=9
	SSPCR1=2;//odblokowanie interfejsu SSP
	for ( i = 0; i < 8; i++ )
	temp = SSPDR; //zerowanie RxFIFO 
}
//zapisanie danej na SPI
void Write_SPI(unsigned char data){
char temp;
	while ( !(SSPSR & 0x02) );//czekaj az FIFO nie bedzie pelny
	SSPDR=data;
	while((SSPSR&4)==0);//czekaj na kompletne przeslanie danej
	 temp = SSPDR; //czysc RxFIFO 
}

unsigned char ReadMedia(void)
{
unsigned char data;
	//while ((SSPSR & 0x04)==4 )//czekaj az FIFO nie bedzie pelny
	//data=SSPDR;
	
	SSPDR=0xff;//do karty same jedynki
	while((SSPSR&1)==1);//czekaj na wpisanie danej do FIFO
	while((SSPSR&4)==0);//czekaj na odbior danej z SPI
	data=SSPDR;
	return(data);                 	
}
unsigned char get_cmd(unsigned char sd_cmd)
{return(CmdTab[sd_cmd][0]);}
unsigned char get_crc(unsigned char sd_cmd)
{return(CmdTab[sd_cmd][1]);}
unsigned char get_rsp(unsigned char sd_cmd)
{return(CmdTab[sd_cmd][2]);}
unsigned char get_tdata(unsigned char sd_cmd)
{return(CmdTab[sd_cmd][3]);}
//inicjalizacja karty SD
unsigned int MediaInitialize(void)
{
unsigned short timeout=0;
unsigned int CSDstatus=0;
unsigned int resp=0; 
	IO0DIR|=SDC_CS;//linia E wyjsciowa
	status=0;
	SDC_CS_1	//CS=1

 	delay_ms(100);
    for(timeout=0; timeout<10; timeout++)//karta wymaga 80 cykli zegra przy inicjalizacji
	Write_SPI(0xff);  
    SDC_CS_0 	//CS=0 SC aktywny
    delay_ms(10);
    resp = SendSDCCmd(cmdGO_IDLE_STATE,0x0);//wyslij komende CMD0 reset karty (adres 0)
    if(resp == SDC_BAD_RESPONSE)//odpowied 0xFF
    {status = sdcCardInitCommFailure;      //nic nie odebralismy z karty
     goto InitError;} 
    if(resp != 0x01)            //nie ma bedu,ale karta zajta (BUSY)
     {status = sdcCardNotInitFailure;      //nic nie odebralimy z karty 
     goto InitError;}                
     timeout = 0x1FFF;//reset karty poprawny - wysylamy CMD1 procedura inicjalizaci karty (adres 0)
	do{resp = SendSDCCmd(cmdSEND_OP_COND,0x0);//CMD1
	 timeout--;        
     }while(resp != 0); //&& timeout != 0); //probujemy 4096 razy az mnie czas lub otrzymamy potwierdzenie 00

	

    if(timeout == 0)//nie otrzymalismy potwierdzenia        
    {status = sdcCardInitTimeout;      //nie odebralismy nic z karty - blad przekroczenia czasu
     goto InitError;
    }                        
    else  
	{CSDstatus=CSDRead();//odczytaj rejestr CID - CMD2
      if(CSDstatus==0);
	  else 
      {status=sdcCardTypeInvalid;
	   goto InitError;}
	}
	 resp=SendSDCCmd(cmdSET_BLOCKLEN,BLOCKLEN_512);//ustawienie dugoci sektora do odczytu na 512 bajtow
     if(resp!=0)
	{status = sdcCardInitTimeout;      //nie odebralismy nic z karty - blad przekroczenia czasu
	  //DispLcd("tutaj",0,1);
      goto InitError;}
     for(timeout = 0xFF; timeout > 0; timeout--)
     {resp=SectorRead(0x20,msd_buffer);
     if(resp==0)
	 break;}
	
    if(timeout == 0)  
    {status = sdcCardNotInitFailure;
        goto InitError;} 
	return(status);	
    
InitError: 
    SDC_CS_1 //karta nieaktywna 
    return(status);                            
}//end MediaInitialize

unsigned int SendSDCCmd(unsigned char cmd, unsigned int address)
{        
char resp;
unsigned char res_byte_l=0,res_byte_h=0,index;
unsigned int res_out;
unsigned int timeout = 8;

    SDC_CS_0 //CS=0                       
    Write_SPI(get_cmd(cmd)); //wyslij kod komendy
   	Write_SPI(address>>24); //najstarszy bajt argumentu
    Write_SPI(address>>16);//kolejne bajty argumentu
   	Write_SPI(address>>8);
    Write_SPI(address); //najmlodszy bajt argumentu          
    Write_SPI(get_crc(cmd));  //wyslij CRC
	resp=get_rsp(cmd);//typ odpowiedzi karty
    if(resp==R1 || resp==R1b)
    {
	 while(timeout!=0)
	 {res_byte_l=ReadMedia();//czekaj na odpowiedz rozna od 0xFF
	  if(res_byte_l!=0xff)
	  break;
      timeout--;}
    }
    else
	if(resp == R2)
        {ReadMedia();      
        res_byte_l = ReadMedia();
        res_byte_h = ReadMedia();}
    if(resp == R1b)//dodatkowo czekaj na zwolnienie linii danych dla R1b
    {
		res_byte_l = 0x00;
		for(index =0; index < 0xFF && res_byte_l == 0x00; index++)
		{timeout = 0xFFFF;	           
	        do
	        {res_byte_l = ReadMedia();
	          timeout--;
	        }while((res_byte_l == 0x00) && (timeout != 0)); 
		}
    }
    
    if(get_tdata(cmd)==NODATA)//nie sa spodziewane kolejne dane
     {SDC_CS_1 //CS=1
	  Write_SPI(0xff);}
	 if(resp == R1 || resp == R1b)
    return(res_byte_l); //potwierdzenie 1 bajtowe
	if(resp == R2)//poteirdzenie 2 bajtowe, lub 3 bajtowe
	{res_out=res_byte_h;
	 res_out=res_out<<8;
	 res_out=res_out|res_byte_l;
    return(res_out);}  	   
}

unsigned int SectorWrite(short sector_addr, unsigned char *buffer)
{
    int index;
    unsigned char data_response;
	unsigned char resp;
  	
    resp = SendSDCCmd(cmdWRITE_SINGLE_BLOCK,(sector_addr << 9));
    if(resp != 0x00)
        status = sdcCardBadCmd;    
    else
    {
        Write_SPI(0xff);
        Write_SPI(DATA_START_TOKEN);               //Send data start token
        
        for(index = 0; index < 512; index++)      //Send 512 bytes of data
        Write_SPI(buffer[index]);
            
        Write_SPI(0xff);                               //Send 2 bytes of CRC
		Write_SPI(0xff);
        index=16;
        while(index>0)
        {data_response = ReadMedia();              //Read response
		 if((data_response & 0x0F) == DATA_ACCEPTED)
         break;}         
        if(index==0)
        {
            status = sdcCardDataRejected;
        }
        else
        {index = 0;                            //using i as a timeout counter   
            do                                    //Wait for write completion
            {data_response = ReadMedia();
             index++;
            }while((data_response == 0x00) && (index != 0));
            if(index == 0)                        //if timeout first
             status = sdcCardTimeout;
        }
    }
    
    SDC_CS_1 //CS=1
	Write_SPI(0xff);
	
  	return(status);
} //end SectorWrite

unsigned int SectorRead(int sector_addr, unsigned char *buffer)
{
int index;
unsigned short resp=0;
unsigned char data_token;
    resp = SendSDCCmd(cmdREAD_SINGLE_BLOCK,(sector_addr << 9));
    if(resp != 0x00)
    {
        status = sdcCardBadCmd;
    }
    else
    {
        index = 0x2FF;                                     
        do
        {
            data_token = ReadMedia();
            index--;
        }while((data_token == SDC_FLOATING_BUS) && (index != 0));
    
        if((index == 0) || (data_token != DATA_START_TOKEN))//0xFE
            status = sdcCardTimeout;
        else
        {
            for(index = 0; index < SDC_SECTOR_SIZE; index++)
		    buffer[index] = ReadMedia(); //czytanie 512 bajtow danych  
            
		    ReadMedia();//CRC
			ReadMedia();
        }
    }
	SDC_CS_1 //koniec transakcji
	Write_SPI(0xff);
    return(status);
}//end SectorRead

unsigned int CSDRead()
{
    unsigned short index, timeout=0x2ff;
	unsigned int resp;
    unsigned char data_token;

    SDC_CS_0 
    Write_SPI(SEND_CSD);                  
    Write_SPI(0);                
    Write_SPI(0);
    Write_SPI(0);
    Write_SPI(0);                
    Write_SPI(0xaf);                   

    do//czekaj na odpowiedz
      {resp = ReadMedia();
       timeout--;}
	while((resp == 0xFF) && (timeout != 0));

    if(resp != 0x00)
     status = sdcCardBadCmd;
    else//komenda zostala zaakceptowana
    {
        index = 0x2FF;                                     
        do//czekaj na data token (0xFE)
        {
            data_token = ReadMedia();
            index--;
        }while((data_token == SDC_FLOATING_BUS) && (index != 0));
    	
		   for(index = 0; index < CSD_SIZE; index++)//zerowanie bufora CSD
			  csd_buffer[index] = 0;  

        if((index == 0) || (data_token != DATA_START_TOKEN))//nie odebrano data token
            status = sdcCardTimeout;
        else
        {
         for(index = 0; index < CSD_SIZE; index++)//czytaj 16 bajtow CSD
		  csd_buffer[index] = ReadMedia();
        }   
		ReadMedia();
		ReadMedia();
    }
    SDC_CS_1
	Write_SPI(0xff);
    return(status);
}//end CSDRead
//wyliczenie pojemnosci karty
unsigned int sd_cap(void)
{
unsigned int cd_size;
unsigned int size;
unsigned char mult;
	size=(csd_buffer[6]&3);
    size=size<<10;
	size=(size|(csd_buffer[7]<<2));   
	size=size|(csd_buffer[8]>>6);
	mult=(csd_buffer[9]&3)<<1;
	mult=mult|(csd_buffer[10]>>7);
	cd_size=size;
	cd_size=(cd_size+1)<<(mult+2);
    cd_size=cd_size*512;
	return(cd_size);
}

